Subject: Add module menu object to the TYPOS3 backend

Description

The backend at the moment uses a combination of the GLOBAL variables TBE_ MODULES and TBE_ MODULES_EXT to build the
main menus of the backend (the module menu on the left and the submodule menus of the backend modules - look at info for an
example).

To be able to easily change the representation of these menus and to offer a clean API for rendering menus the menu is refactored
into an object structure with n levels. At the moment the old GLOBALS are migrated to a 3 level menu object. This means that you can
use the module menu object in your backend modules to render your submenu.

This patch just adds the object structure and transformation. It does not change any handling of menus in the core itself. These
changes can be done piece by piece after this patch.

Associated revisions

Revision da64930b - 2012-06-24 14:58 - Susanne Moog

[FEATURE] Add module menu object to the TYPO3 backend

The backend at the moment uses a combination of the

GLOBAL variables TBE_MODULES and TBE_MODULES_EXT to
build the main menus of the backend (the module menu

on the left and the submodule menus of the backend

modules - look at info for an example).

To be able to easily change the representation of
these menus and to offer a clean API for rendering
menus the menu is refactored into an object structure
with n levels. This patch migrates the old GLOBALS
to a 3 level menu object. This means that you can use
the module menu object in your backend modules to

render your submenu.

This patch just adds the object structure and
transformation. It does not change any handling of
menus in the core itself. These changes can be done

piece by piece after this patch.

Change-Id: 11f7f9f5fcf83274840acef6cbeb267ea4cad60c3
Resolves: #38138
Releases: 6.0
Reviewed-on: http://review.typo3.org/12146

Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

Revision 9119052 - 2012-07-13 19:56 - Susanne Moog

[FEATURE] Add module menu object to the TYPO3 backend

The backend at the moment uses a combination of the

GLOBAL variables TBE_MODULES and TBE_MODULES_EXT to
build the main menus of the backend (the module menu

on the left and the submodule menus of the backend

modules - look at info for an example).

To be able to easily change the representation of
these menus and to offer a clean API for rendering
menus the menu is refactored into an object structure
with n levels. This patch migrates the old GLOBALS
to a 3 level menu object. This means that you can use
the module menu object in your backend modules to

render your submenu.

This patch just adds the object structure and
transformation. It does not change any handling of
menus in the core itself. These changes can be done
piece by piece after this patch.

Change-Id: [1f7f9f5fcf83274840acef6cbeb267ea4cad60c3
Resolves: #38138

Releases: 6.0

Reviewed-on: http://review.typo3.org/12146

Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

History

#1 - 2012-06-17 14:17 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.

It is available at http://review.typo3.org/12146

#2 - 2012-06-17 14:21 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.

It is available at http://review.typo3.org/12146
#3 - 2012-06-17 14:22 - Susanne Moog

You can test the change with adding

$moduleMenu = t3lib_div::makelnstance('Typo3_ModuleMenu'); var_dump($moduleMenu);
for example in the about index controller and having a look at the source code.

#4 - 2012-06-18 20:00 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12146

#5 - 2012-06-18 20:10 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12146

#6 - 2012-06-24 01:07 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12146

#7 - 2012-06-24 14:50 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12146

#8 - 2012-06-24 15:30 - Susanne Moog
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:da64930b319d437e6e0ee3df62480018684aa6d5.
